/**
* Търсене в ширина
* (ориентиран граф)
*/

#include <iostream>
#include <vector>
using namespace std;

const int NMAX = 1000;
const int MMAX = 10000;

int n,m;
vector<int> a[NMAX];

int vis[NMAX];
int q[NMAX];
int first, last;

void bfs(int s)
{ vis[s] = 1;
  q[last] = s; last++; // включване в опашката

  while(first<last) // докато опашката не е празна
  { int u = q[first]; first++; // изключване
    for(int v: a[u])
      if(vis[v]==0)
      { vis[v] = 1;
        q[last] = v; last++;
      }
  }
}

int main()
{ cin >> n;
  cin >> m;

  for(int i=0; i<m; i++)
  { int u,v;
    cin >> u >> v;
    a[u].push_back(v);
  }

  first = last = 0; // празна опашка

  for(int u=1; u<=n; u++)
    vis[u] = 0;

  for(int s=1; s<=n; s++)
    if(vis[s]==0)
      bfs(s);

  for(int i=0; i<n; i++)
    cout << q[i] << " ";
  cout << endl;

  return 0;
}
