/**
* Приложение на dfs
* за намиране на
* свързаните компоненти
* (неориентиран граф)
*/

#include <iostream>
#include <vector>
using namespace std;

const int NMAX = 1000;
const int MMAX = 10000;

int n,m;
vector<int> a[NMAX];

int vis[NMAX];

void dfs(int u)
{ vis[u] = 1;
// preorder
  cout << u << " ";

  for(int v: a[u])
    if(vis[v]==0)
      dfs(v);
// postorder

}

int main()
{ cin >> n;
  cin >> m;

  for(int i=0; i<m; i++)
  { int u,v;
    cin >> u >> v;
    a[u].push_back(v);
    a[v].push_back(u);
  }

  for(int u=1; u<=n; u++)
  { cout << u << ":";
    for(int v: a[u])
      cout << " " << v;
    cout << endl;
  }


  for(int u=1; u<=n; u++)
    vis[u] = 0;

  int answer=0;

  for(int u=1; u<=n; u++)
    if(vis[u]==0)
    { answer++;
      dfs(u);
      cout << endl;
    }
  cout<<answer<<endl;

  return 0;
}
